#include <Servo.h> 
 
Servo Elbow; 
Servo Shoulder;
Servo Dropper;

int Pocket1=0;// 0 = None  1 = Human   2 = AI
int Pocket2=0;
int Pocket3=0;
int Pocket4=0;
int Pocket5=0;
int Pocket6=0;
int Pocket7=0;
int Pocket8=0;
int Pocket9=0;
 
 
void setup() 
{ 
  Elbow.attach(9);
  Shoulder.attach(10);
  Dropper.attach(11);
  Dropper.write(120);
  pinMode(5, INPUT);
  HomeArm(); 
  delay(1000); 
  while(!digitalRead(2)){}//wait for human to press button
  delay(500);
} 
 
 
void loop() 
{ 
  Drop1();      //
  Drop();       //
  Pocket1=2;    //  AI makes first move
  delay(200);   //
  HomeArm();    //
  
  while(!digitalRead(5)){}//wait for human to press button
  delay(500);
  
  //scan board
  while(true){
    Check1();
    if(Check2()>800){
      Pocket2=1;
      break;
    }
    else if(Check3()>800){
      Pocket3=1;
      break;
    }
    else if(Check4()>800){
      Pocket4=1;
      break;
    }
    else if(Check5()>800){
      Pocket5=1;
      break;
    }
    else if(Check6()>800){
      Pocket6=1;
      break;
    }
    else if(Check7()>800){
      Pocket7=1;
      break;
    }
    else if(Check8()>800){
      Pocket8=1;
      break;
    }
    else if(Check9()>800){
      Pocket9=1;
      break;
    }
    else{}
  }
  
  HomeArm(); 
  delay(1000);
  
  if((Pocket2==1)||(Pocket8)){
    Game1();
  }
  else if(Pocket3==1){
    Game2();
  }
  else if((Pocket4==1)||(Pocket7==1)){
    Game3();
  }
  else if(Pocket5==1){
    Game4();
  }
  else{
    Game5();
  }
}

void Game1(){
  Drop7();
  Drop();
  Pocket7=2;
  delay(200);
  HomeArm();
  delay(1000);
  
  while(!digitalRead(5)){}//wait for human to press button
  delay(500);
  
  //scan board
  while(true){
    if((Check1()>800)&&(Pocket1==0)){
      Pocket1=1;
      break;
    }
    else if((Check2()>800)&&(Pocket2==0)){
      Pocket2=1;
      break;
    }
    else if((Check3()>800)&&(Pocket3==0)){
      Pocket3=1;
      break;
    }
    else if((Check4()>800)&&(Pocket4==0)){
      Pocket4=1;
      break;
    }
    else if((Check5()>800)&&(Pocket5==0)){
      Pocket5=1;
      break;
    }
    else if((Check6()>800)&&(Pocket6==0)){
      Pocket6=1;
      break;
    }
    else if((Check7()>800)&&(Pocket7==0)){
      Pocket7=1;
      break;
    }
    else if((Check8()>800)&&(Pocket8==0)){
      Pocket8=1;
      break;
    }
    else if((Check9()>800)&&(Pocket9==0)){
      Pocket9=1;
      break;
    }
    else{}
  }
  
  HomeArm(); 
  delay(1000);
  
  if(Pocket4==0){
    Drop4();
    Drop();
    Pocket4=2;
    delay(200);
    HomeArm(); 
    delay(100000000);//Wins
  }
  else{
    Drop5();
    Drop();
    Pocket5=2;
    delay(200);
  }
  
  HomeArm(); 
  delay(1000);
  
  while(!digitalRead(5)){}//wait for human to press button
  delay(500);
  
  //scan board
  while(true){
    if((Check1()>800)&&(Pocket1==0)){
      Pocket1=1;
      break;
    }
    else if((Check2()>800)&&(Pocket2==0)){
      Pocket2=1;
      break;
    }
    else if((Check3()>800)&&(Pocket3==0)){
      Pocket3=1;
      break;
    }
    else if((Check4()>800)&&(Pocket4==0)){
      Pocket4=1;
      break;
    }
    else if((Check5()>800)&&(Pocket5==0)){
      Pocket5=1;
      break;
    }
    else if((Check6()>800)&&(Pocket6==0)){
      Pocket6=1;
      break;
    }
    else if((Check7()>800)&&(Pocket7==0)){
      Pocket7=1;
      break;
    }
    else if((Check8()>800)&&(Pocket8==0)){
      Pocket8=1;
      break;
    }
    else if((Check9()>800)&&(Pocket9==0)){
      Pocket9=1;
      break;
    }
    else{}
  }
  
  HomeArm(); 
  delay(1000);
  
  if(Pocket3==1){
    Drop9();
    Drop();
    Pocket9=2;
    delay(200);
  }
  else{
    Drop3();
    Drop();
    Pocket3=2;
    delay(200);
  }
  
  HomeArm(); 
  delay(10000000);//Wins
}
  

void Game2(){
  Drop9();
  Drop();
  Pocket9=2;
  delay(200);
  HomeArm();
  delay(1000);
  
  while(!digitalRead(5)){}//wait for human to press button
  delay(500);
  
  //scan board
  while(true){
    if((Check1()>800)&&(Pocket1==0)){
      Pocket1=1;
      break;
    }
    else if((Check2()>800)&&(Pocket2==0)){
      Pocket2=1;
      break;
    }
    else if((Check3()>800)&&(Pocket3==0)){
      Pocket3=1;
      break;
    }
    else if((Check4()>800)&&(Pocket4==0)){
      Pocket4=1;
      break;
    }
    else if((Check5()>800)&&(Pocket5==0)){
      Pocket5=1;
      break;
    }
    else if((Check6()>800)&&(Pocket6==0)){
      Pocket6=1;
      break;
    }
    else if((Check7()>800)&&(Pocket7==0)){
      Pocket7=1;
      break;
    }
    else if((Check8()>800)&&(Pocket8==0)){
      Pocket8=1;
      break;
    }
    else if((Check9()>800)&&(Pocket9==0)){
      Pocket9=1;
      break;
    }
    else{}
  }
  
  HomeArm(); 
  delay(1000);
  
  if(Pocket5==0){
    Drop5();
    Drop();
    Pocket5=2;
    delay(200);
    HomeArm(); 
    delay(100000000);//Wins
  }
  else{
    Drop7();
    Drop();
    Pocket7=2;
    delay(200);
  }
  
  HomeArm(); 
  delay(1000);
  
  while(!digitalRead(5)){}//wait for human to press button
  delay(500);
  
  //scan board
  while(true){
    if((Check1()>800)&&(Pocket1==0)){
      Pocket1=1;
      break;
    }
    else if((Check2()>800)&&(Pocket2==0)){
      Pocket2=1;
      break;
    }
    else if((Check3()>800)&&(Pocket3==0)){
      Pocket3=1;
      break;
    }
    else if((Check4()>800)&&(Pocket4==0)){
      Pocket4=1;
      break;
    }
    else if((Check5()>800)&&(Pocket5==0)){
      Pocket5=1;
      break;
    }
    else if((Check6()>800)&&(Pocket6==0)){
      Pocket6=1;
      break;
    }
    else if((Check7()>800)&&(Pocket7==0)){
      Pocket7=1;
      break;
    }
    else if((Check8()>800)&&(Pocket8==0)){
      Pocket8=1;
      break;
    }
    else if((Check9()>800)&&(Pocket9==0)){
      Pocket9=1;
      break;
    }
    else{}
  }
  
  HomeArm(); 
  delay(1000);
  
  if(Pocket4==1){
    Drop8();
    Drop();
    Pocket8=2;
    delay(200);
  }
  else{
    Drop4();
    Drop();
    Pocket4=2;
    delay(200);
  }
  
  HomeArm(); 
  delay(10000000);//Wins
}

void Game3(){
  Drop2();
  Drop();
  Pocket2=2;
  delay(200);
  HomeArm();
  delay(1000);
  
  while(!digitalRead(5)){}//wait for human to press button
  delay(500);
  
  //scan board
  while(true){
    if((Check1()>800)&&(Pocket1==0)){
      Pocket1=1;
      break;
    }
    else if((Check2()>800)&&(Pocket2==0)){
      Pocket2=1;
      break;
    }
    else if((Check3()>800)&&(Pocket3==0)){
      Pocket3=1;
      break;
    }
    else if((Check4()>800)&&(Pocket4==0)){
      Pocket4=1;
      break;
    }
    else if((Check5()>800)&&(Pocket5==0)){
      Pocket5=1;
      break;
    }
    else if((Check6()>800)&&(Pocket6==0)){
      Pocket6=1;
      break;
    }
    else if((Check7()>800)&&(Pocket7==0)){
      Pocket7=1;
      break;
    }
    else if((Check8()>800)&&(Pocket8==0)){
      Pocket8=1;
      break;
    }
    else if((Check9()>800)&&(Pocket9==0)){
      Pocket9=1;
      break;
    }
    else{}
  }
  
  HomeArm(); 
  delay(1000);
  
  if(Pocket3==0){
    Drop3();
    Drop();
    Pocket3=2;
    delay(200);
    HomeArm(); 
    delay(100000000);//Wins
  }
  else{
    Drop5();
    Drop();
    Pocket5=2;
    delay(200);
  }
  
  HomeArm(); 
  delay(1000);
  
  while(!digitalRead(5)){}//wait for human to press button
  delay(500);
  
  //scan board
  while(true){
    if((Check1()>800)&&(Pocket1==0)){
      Pocket1=1;
      break;
    }
    else if((Check2()>800)&&(Pocket2==0)){
      Pocket2=1;
      break;
    }
    else if((Check3()>800)&&(Pocket3==0)){
      Pocket3=1;
      break;
    }
    else if((Check4()>800)&&(Pocket4==0)){
      Pocket4=1;
      break;
    }
    else if((Check5()>800)&&(Pocket5==0)){
      Pocket5=1;
      break;
    }
    else if((Check6()>800)&&(Pocket6==0)){
      Pocket6=1;
      break;
    }
    else if((Check7()>800)&&(Pocket7==0)){
      Pocket7=1;
      break;
    }
    else if((Check8()>800)&&(Pocket8==0)){
      Pocket8=1;
      break;
    }
    else if((Check9()>800)&&(Pocket9==0)){
      Pocket9=1;
      break;
    }
    else{}
  }
  
  HomeArm(); 
  delay(1000);
  
  if(Pocket8==1){
    Drop9();
    Drop();
    Pocket9=2;
    delay(200);
  }
  else{
    Drop8();
    Drop();
    Pocket8=2;
    delay(200);
  }
  
  HomeArm(); 
  delay(10000000);//Wins
}

void Game4(){
  Drop4();
  Drop();
  Pocket4=2;
  delay(200);
  HomeArm();
  delay(1000);
  
  while(!digitalRead(5)){}//wait for human to press button
  delay(500);
  
  //scan board
  while(true){
    if((Check1()>800)&&(Pocket1==0)){
      Pocket1=1;
      break;
    }
    else if((Check2()>800)&&(Pocket2==0)){
      Pocket2=1;
      break;
    }
    else if((Check3()>800)&&(Pocket3==0)){
      Pocket3=1;
      break;
    }
    else if((Check4()>800)&&(Pocket4==0)){
      Pocket4=1;
      break;
    }
    else if((Check5()>800)&&(Pocket5==0)){
      Pocket5=1;
      break;
    }
    else if((Check6()>800)&&(Pocket6==0)){
      Pocket6=1;
      break;
    }
    else if((Check7()>800)&&(Pocket7==0)){
      Pocket7=1;
      break;
    }
    else if((Check8()>800)&&(Pocket8==0)){
      Pocket8=1;
      break;
    }
    else if((Check9()>800)&&(Pocket9==0)){
      Pocket9=1;
      break;
    }
    else{}
  }
  
  HomeArm(); 
  delay(1000);
  
  if(Pocket7==0){
    Drop7();
    Drop();
    Pocket7=2;
    delay(200);
    HomeArm(); 
    delay(100000000);//Wins
  }
  else{
    Drop3();
    Drop();
    Pocket3=2;
    delay(200);
  }
  
  HomeArm(); 
  delay(1000);
  
  while(!digitalRead(5)){}//wait for human to press button
  delay(500);
  
  //scan board
  while(true){
    if((Check1()>800)&&(Pocket1==0)){
      Pocket1=1;
      break;
    }
    else if((Check2()>800)&&(Pocket2==0)){
      Pocket2=1;
      break;
    }
    else if((Check3()>800)&&(Pocket3==0)){
      Pocket3=1;
      break;
    }
    else if((Check4()>800)&&(Pocket4==0)){
      Pocket4=1;
      break;
    }
    else if((Check5()>800)&&(Pocket5==0)){
      Pocket5=1;
      break;
    }
    else if((Check6()>800)&&(Pocket6==0)){
      Pocket6=1;
      break;
    }
    else if((Check7()>800)&&(Pocket7==0)){
      Pocket7=1;
      break;
    }
    else if((Check8()>800)&&(Pocket8==0)){
      Pocket8=1;
      break;
    }
    else if((Check9()>800)&&(Pocket9==0)){
      Pocket9=1;
      break;
    }
    else{}
  }
  
  HomeArm(); 
  delay(1000);
  
  if(Pocket2==1){
    Drop8();
    Drop();
    Pocket8=2;
    delay(200);
  }
  else{
    Drop2();
    Drop();
    Pocket2=2;
    delay(200);
  }
  
  HomeArm(); 
  delay(10000000);//Wins
}

void Game5(){
  Drop3();
  Drop();
  Pocket3=2;
  delay(200);
  HomeArm();
  delay(1000);
  
  while(!digitalRead(5)){}//wait for human to press button
  delay(500);
  
  //scan board
  while(true){
    if((Check1()>800)&&(Pocket1==0)){
      Pocket1=1;
      break;
    }
    else if((Check2()>800)&&(Pocket2==0)){
      Pocket2=1;
      break;
    }
    else if((Check3()>800)&&(Pocket3==0)){
      Pocket3=1;
      break;
    }
    else if((Check4()>800)&&(Pocket4==0)){
      Pocket4=1;
      break;
    }
    else if((Check5()>800)&&(Pocket5==0)){
      Pocket5=1;
      break;
    }
    else if((Check6()>800)&&(Pocket6==0)){
      Pocket6=1;
      break;
    }
    else if((Check7()>800)&&(Pocket7==0)){
      Pocket7=1;
      break;
    }
    else if((Check8()>800)&&(Pocket8==0)){
      Pocket8=1;
      break;
    }
    else if((Check9()>800)&&(Pocket9==0)){
      Pocket9=1;
      break;
    }
    else{}
  }
  
  HomeArm(); 
  delay(1000);
  
  if(Pocket2==0){
    Drop2();
    Drop();
    Pocket2=2;
    delay(200);
    HomeArm(); 
    delay(100000000);//Wins
  }
  else{
    Drop7();
    Drop();
    Pocket7=2;
    delay(200);
  }
  
  HomeArm(); 
  delay(1000);
  
  while(!digitalRead(5)){}//wait for human to press button
  delay(500);
  
  //scan board
  while(true){
    if((Check1()>800)&&(Pocket1==0)){
      Pocket1=1;
      break;
    }
    else if((Check2()>800)&&(Pocket2==0)){
      Pocket2=1;
      break;
    }
    else if((Check3()>800)&&(Pocket3==0)){
      Pocket3=1;
      break;
    }
    else if((Check4()>800)&&(Pocket4==0)){
      Pocket4=1;
      break;
    }
    else if((Check5()>800)&&(Pocket5==0)){
      Pocket5=1;
      break;
    }
    else if((Check6()>800)&&(Pocket6==0)){
      Pocket6=1;
      break;
    }
    else if((Check7()>800)&&(Pocket7==0)){
      Pocket7=1;
      break;
    }
    else if((Check8()>800)&&(Pocket8==0)){
      Pocket8=1;
      break;
    }
    else if((Check9()>800)&&(Pocket9==0)){
      Pocket9=1;
      break;
    }
    else{}
  }
  
  HomeArm(); 
  delay(1000);
  
  if(Pocket4==1){
    Drop5();
    Drop();
    Pocket5=2;
    delay(200);
  }
  else{
    Drop4();
    Drop();
    Pocket4=2;
    delay(200);
  }
  
  HomeArm(); 
  delay(10000000);//Wins
}
    
  
  
  

void HomeArm(){
  Elbow.write(140); 
  Shoulder.write(100);
  return;  
} 

void Drop(){
  Dropper.write(140);
  delay(200);
  Dropper.write(120);
  delay(500);
  return;
}
  

void Drop1(){//
  Elbow.write(107); 
  Shoulder.write(138);
  delay(1000);
  return;
}

void Drop2(){//
  Elbow.write(120); 
  Shoulder.write(143);
  delay(1000);
  return;
}

void Drop3(){//
  Elbow.write(127); 
  Shoulder.write(135);
  delay(1000);
  return;
}

void Drop4(){//
  Elbow.write(85); 
  Shoulder.write(112);
  delay(1000);
  return;
}

void Drop5(){//
  Elbow.write(97); 
  Shoulder.write(112);
  delay(1000);
  return;
}

void Drop6(){//
  Elbow.write(100); 
  Shoulder.write(105);
  delay(1000);
  return;
}

void Drop7(){//
  Elbow.write(60); 
  Shoulder.write(86);
  delay(1000);
  return;
}

void Drop8(){
  Elbow.write(65); 
  Shoulder.write(80);
  delay(1000);
  return;
}

void Drop9(){
  Elbow.write(62); 
  Shoulder.write(67);
  delay(1000);
  return;
}
  

int Check1(){
  Elbow.write(82); 
  Shoulder.write(110);
  delay(1000);
  return analogRead(A0);  
} 

int Check2(){
  Elbow.write(95); 
  Shoulder.write(105);
  delay(500);  
  return analogRead(A0);
} 

int Check3(){
  Elbow.write(100); 
  Shoulder.write(95); 
  delay(500);
  return analogRead(A0); 
} 

int Check4(){
  Elbow.write(57); 
  Shoulder.write(80);
  delay(700);
  return analogRead(A0);  
} 

int Check5(){
  Elbow.write(65); 
  Shoulder.write(75);
  delay(500);  
  return analogRead(A0);
}

int Check6(){
  Elbow.write(75); 
  Shoulder.write(70);
  delay(500);
  return analogRead(A0);
}

int Check7(){
  Elbow.write(5); 
  Shoulder.write(40);
  delay(700);
  return analogRead(A0);  
}

int Check8(){
  Elbow.write(43); 
  Shoulder.write(60);
  delay(500);  
  return analogRead(A0);
}

int Check9(){
  Elbow.write(40); 
  Shoulder.write(45);
  delay(500);  
  return analogRead(A0); 
}




